/*======================================================================================================================
 *      File: Relay.h
 *   Project: Remote Outlet
 *  Firmware: 0300
 *  Hardware: 0300
 * Processor: ATmega328p
 * Frequency: 16.0 MHz
 *   Created: 2014-10-15
 *  Modified: 2014-10-20
 *    Author: eX Systems
 *     Email: jaredjulien@exsystems.net
 * Copyright: (c) 2014 eX Systems
 *
 * --------------------------------------------------------------------------------------------------------------------
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated
 * documentation files (the "Software"), to deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
 * Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS
 * OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * --------------------------------------------------------------------------------------------------------------------
 *
 * Date        Rev   Author    Change Description
 * ==========  ====  ========  ========================================================================================
 * 2014-10-20  1     Jared     Initial file creation
 * --------------------------------------------------------------------------------------------------------------------
 */
#ifndef RELAY_H
#define RELAY_H
//======================================================================================================================
// Relay Class
//----------------------------------------------------------------------------------------------------------------------
class Relay
{
	public:
		Relay(uint8_t pin);
		void begin(void);
		uint8_t toggle(void);
		void on(void);
		void off(void);

	private:
		uint8_t _state;
		uint8_t _pin;
};


#endif /* RELAY_H */
/* End of file: Relay.h */